<template>
  <table class="wrapper">
    <!-- Assumes chronologically ascending order assured by backend -->
    <tr v-if="events.length === 0">
      <td rowspan="3">{{ t("no_events_message") }}</td>
    </tr>
    <tr v-else v-for="(event, idx) in events" :key="event.id">
      <td>{{ formatStartDate(event, idx) }}</td>
      <td class="event__title">
        {{ event.summary.trim() }}
        <span v-show="currentSettings.showLocation" class="event__location"
        ><br/>{{ event.location }}</span
        >
      </td>
      <td :class="{imperial: currentSettings.hour12 === 'true'}">
        <template v-if="event.several_days">
          …
          <template v-if="!endsToday(event.dtend, event.all_day)">
            {{ formatEndDate(event.dtend, event.all_day) }}
          </template>
          <i v-if="event.all_day" :style="iconStyles" v-html="icon"></i>
          <template v-else>
            {{ formatTime(event.dtstart) }}
          </template>
        </template>
        <template v-else-if="event.hasStarted"
        >… {{ formatTime(event.dtend) }}
        </template>
        <i v-else-if="event.all_day" :style="iconStyles" v-html="icon"></i>
        <template v-else>
          {{ formatTime(event.dtstart) }}
        </template>
      </td>
    </tr>
  </table>
</template>
<script>
module.exports = {
  name: "calendar-event-list",
  props: {
    currentSettings: {
      type: Object,
      required: true
    },
    currentStyles: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: true
    }
  },
  formatterOptions: {
    date: {
      month: "2-digit",
      day: "2-digit"
    },
    time: {
      hour: "2-digit",
      minute: "2-digit"
    }
  },
  asyncComputed: {
    icon: function () {
      return this.fetchAsset("icons", "24-hours.svg");
    }
  },
  computed: {
    events: function () {
      const now = new Date(); // Fixed value for all filter functions
      let mapped = this.records.reduce((acc, record) => {
        // Guard against incomplete data. TODO: Use optional chaining once compiling.
        if (
            record.attributes === undefined ||
            record.attributes.events === undefined
        )
          return;
        const normalized = record.attributes.events.map(event => {
          const startDateParsed = new Date(event.dtstart);
          const endDateParsed = new Date(event.dtend);
          let copy = {...event};
          copy.calendar = record.attributes.name;
          copy.dtstart = startDateParsed;
          copy.dtend = endDateParsed;
          copy.hasStarted = startDateParsed <= now;
          return copy;
        });
        return acc.concat(normalized);
      }, []);
      if (!this.currentSettings.showCurrentEvents) {
        mapped = mapped.filter(this.filterPastEvents(now));
      }
      const sorted = mapped.sort((a, b) => a.dtstart - b.dtstart);
      let subset = [];
      switch (this.currentSettings.displaymode) {
        case "amount":
          subset = sorted.slice(0, this.currentSettings.eventAmount);
          break;
        case "timeframe":
          subset = sorted.filter(event => this.filterByDate(now, event));
          break;
        default:
          break;
      }
      return subset;
    },
    iconStyles: function () {
      return {
        height: `${(this.currentStyles.fontSize / 100)}rem`
      }
    }
  },
  methods: {
    filterPastEvents: function (now) {
      return function (event) {
        const filter = event.all_day ? event.dtend : event.dtstart;
        return filter >= now;
      };
    },
    filterByDate: function (now, event) {
      const restOfTheDay = new Date(now).setHours(23, 59, 59, 999);
      const oneDay = 86400000; /* 1000ms * 60s * 60m * 24h = 1 day */
      return (
          event.dtstart.valueOf() <= restOfTheDay + oneDay * this.currentSettings.daysAhead
      );
    },
    /**
     * Checks if an event ends today. Takes into account all-day events which end at midnight UTC of the following day.
     * @param {Date} date The event's end date.
     * @param {boolean} allDayEvent Whether the event is an all-day event.
     */
    endsToday: function (date, allDayEvent) {
      let comparison = new Date();
      if (allDayEvent) {
        comparison = new Date(Date.now() + 86400000);
      }
      return this.sameDate(date, comparison);
    },
    /**
     * Checks if two date objects have the same date/month/year.
     * @param {Date} a
     * @param {Date} b
     */
    sameDate: function (a, b) {
      return (
          a.getFullYear() === b.getFullYear() &&
          a.getMonth() === b.getMonth() &&
          a.getDate() === b.getDate()
      );
    },
    /**
     * Formats a start date.
     *
     * If the event occurs at the same date (or has also started), returns null so that the row header is visually grouped.
     * @param {object} event An event object
     * @param {number} idx The event's index in the `this.events` array
     */
    formatStartDate: function (event, idx) {
      if (idx === 0) {
        return event.hasStarted
            ? this.$translate.text("now_label")
            : this.formatDate(event.dtstart);
      }
      const previous = this.events[idx - 1];
      if (previous.hasStarted && event.hasStarted) {
        return null;
      }
      if (previous.hasStarted) {
        return this.formatDate(event.dtstart);
      }
      if (this.sameDate(event.dtstart, previous.dtstart)) {
        return null;
      }
      return this.formatDate(event.dtstart);
    },
    /**
     * Formats an event's end-date.
     *
     * If the event is an all-day event, half a day is subtracted sinc end-dates of all-day events are usually midnight UTC of the following day.
     * @param {Date} date an event's end date.
     * @param {boolean} allDayEvent Whether the event is an all-day event.
     */
    formatEndDate: function (date, allDayEvent) {
      if (allDayEvent) {
        date = new Date(date.getTime() - 43200000);
      }
      return this.formatDate(date);
    },
    /**
     * Formats a date according to the current locale.
     * @param {Date} date an event date.
     */
    formatDate: function (date) {
      const now = new Date();

      // TODO: Evaluate formatToParts once support is better
      if (date <= now) {
        return this.$translate.text("now_label");
      }

      if (this.sameDate(date, now)) {
        return this.$translate.text("today_label");
      }

      const tomorrow = new Date(now.getTime() + 86400000);
      if (this.sameDate(date, tomorrow)) {
        return this.$translate.text("tomorrow_label");
      }

      return new Intl.DateTimeFormat(this.language, {
        ...this.$options.formatterOptions.date
      }).format(date);
    },
    /**
     * Formats an event's start/end time according to the current locale.
     * @param {Date} time an event date object.
     */
    formatTime: function (time) {
      const options = {
        ...this.$options.formatterOptions.time,
        hour12: this.currentSettings.hour12 === "true"
      };
      return new Intl.DateTimeFormat(this.language, options).format(time);
    }
  },
  locales: {
    enGb: {
      configuration_message:
          "Please configure the data sources for this widget.",
      no_events_message: "No events in the chosen time period",
      now_label: "now",
      today_label: "today",
      tomorrow_label: "tomorrow"
    },
    deDe: {
      configuration_message:
          "Bitte konfiguriere die Datenquellen für dieses Widget.",
      no_events_message: "Keine Termine im gewählten Zeitraum",
      now_label: "jetzt",
      today_label: "heute",
      tomorrow_label: "morgen"
    },
    frFr: {
      configuration_message:
          "Veuillez configurer les sources de données pour ce widget.",
      no_events_message: "Aucune nomination dans la période sélectionnée",
      now_label: "maintenant",
      today_label: "aujourd'hui",
      tomorrow_label: "demain"
    },
    esEs: {
      configuration_message:
          "Por favor, configure las fuentes de datos de este widget.",
      no_events_message: "No hay eventos en el período de tiempo seleccionado",
      now_label: "ahora",
      today_label: "Hoy en día",
      tomorrow_label: "mañana"
    },
    plPl: {
      configuration_message:
          "Proszę skonfigurować źródła danych dla tego widżetu.",
      no_events_message: "Brak zdarzeń w wybranym okresie czasu",
      now_label: "Teraz",
      today_label: "Dziś",
      tomorrow_label: "Jutro"
    },
    koKr: {
      configuration_message: "이 위젯에 대한 데이터 소스를 구성하십시오.",
      no_events_message: "선택한 기간 동안 이벤트가 없습니다",
      now_label: "지금",
      today_label: "오늘",
      tomorrow_label: "내일"
    }
  }
};
</script>

<style scoped>
.wrapper {
  width: 100%;
}

svg {
  height: inherit;
}

.event__title {
  overflow: hidden;
  display: -webkit-box;
  -webkit-line-clamp: 3;
  -webkit-box-orient: vertical;
}

.event__location {
  font-size: 70%;
}

.imperial {
  min-width: 4.5rem;
}

td {
  vertical-align: top;
  padding-bottom: 0.5rem;
}

td:first-of-type {
  font-weight: bold;
}

td:last-of-type:not(:first-child) {
  vertical-align: baseline;
  text-align: right;
}
</style>
